unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, StdCtrls, DBCtrls, DB, DBTables,
  ExtCtrls, Menus, Buttons;

type
  TMainForm = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    Table1: TTable;
    DataSource1: TDataSource;
    DBText1: TDBText;
    DBText2: TDBText;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DBText3: TDBText;
    DBText4: TDBText;
    DBText5: TDBText;
    DBText6: TDBText;
    Label5: TLabel;
    DBText7: TDBText;
    DataSource2: TDataSource;
    ID: TLabel;
    Ausleihe: TLabel;
    Label6: TLabel;
    DBText8: TDBText;
    DBText9: TDBText;
    DBText10: TDBText;
    DBText11: TDBText;
    Autor: TLabel;
    Titel: TLabel;
    Label7: TLabel;
    DBText12: TDBText;
    DBText13: TDBText;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    Button1: TButton;
    Button2: TButton;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    Person1: TMenuItem;
    Hinzufgen1: TMenuItem;
    Lschen1: TMenuItem;
    Ausleihe1: TMenuItem;
    Hinzufgen2: TMenuItem;
    Lschen2: TMenuItem;
    Suchen1: TMenuItem;
    Table2ID: TIntegerField;
    Table2PID: TIntegerField;
    Table2Datum: TDateField;
    Table2Rueck: TDateField;
    Table2Inv: TStringField;
    Table2Autor: TStringField;
    Table2Titel: TStringField;
    Bearbeiten1: TMenuItem;
    Label8: TLabel;
    PrintButton: TButton;
    PrintDialog1: TPrintDialog;
    Drucken1: TMenuItem;
    Personen1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Hinzufgen1Click(Sender: TObject);
    procedure Lschen1Click(Sender: TObject);
    procedure Suchen1Click(Sender: TObject);
    procedure Hinzufgen2Click(Sender: TObject);
    procedure Lschen2Click(Sender: TObject);
    procedure Bearbeiten1Click(Sender: TObject);
    procedure DataSource2DataChange(Sender: TObject; Field: TField);
    procedure PrintButtonClick(Sender: TObject);
    procedure Table2AfterInsert(DataSet: TDataset);
    procedure Personen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
uses pers,buch,pers_s,druck,
     printers;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  BuchForm.show;
end;

procedure TMainForm.DBGrid1DblClick(Sender: TObject);
begin
  Table2.edit;
  if table2.fieldbyname('Rueck').AsDateTime=date then
    table2.fieldbyname('Rueck').clear
  else if table2.fieldbyname('Rueck').asstring='' then
    table2.fieldbyname('Rueck').AsDateTime:=date;
  table2.post;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if PersSearchForm.showmodal=mrOK then
    table1.gotocurrent(PersSearchForm.table1);
  button1.setfocus;
end;

procedure TMainForm.Beenden1Click(Sender: TObject);
begin
  close;
end;

procedure TMainForm.Hinzufgen1Click(Sender: TObject);
begin
  PersForm.table1.append;
  if PersForm.showmodal=mrOK then
    Table1.gotocurrent(PersForm.table1);
end;

procedure TMainForm.Lschen1Click(Sender: TObject);
begin
  if table2.recordcount<>0 then
     MessageDlg('Sie knnen die Person nicht lschen, da noch Bcher in der Liste stehen!',
     mtError, [mbOK], 0)
  else if MessageDlg('Person wirklich lschen?',mtInformation, [mbYes, mbNo], 0) = mrYes then
    table1.delete;
end;

procedure TMainForm.Suchen1Click(Sender: TObject);
begin
  Button2.click;
end;

procedure TMainForm.Hinzufgen2Click(Sender: TObject);
begin
  button1.click;
end;

procedure TMainForm.Lschen2Click(Sender: TObject);
begin
  if MessageDlg('Buch wirklich aus Ausleihliste lschen?',
                mtInformation, [mbYes, mbNo], 0) = mrYes then
    table2.delete;
end;

procedure TMainForm.Bearbeiten1Click(Sender: TObject);
begin
  PersForm.table1.gotocurrent(table1);
  PersForm.table1.edit;
  if PersForm.showmodal=mrOK then
    Table1.gotocurrent(PersForm.table1);
end;

procedure TMainForm.DataSource2DataChange(Sender: TObject; Field: TField);
begin
  label8.caption:=inttostr(table2.recordcount);
end;

procedure TMainForm.PrintButtonClick(Sender: TObject);
var x,y:integer;
  procedure Out(s:string; len:byte);
  var i:byte;
  begin
    while length(s)>0 do begin
      i:=len;
      if i>length(s) then i:=length(s)
                     else while s[i] in ['a'..'z','A'..'Z'] do dec(i);
      printer.canvas.textout(x,y,copy(s,1,i));
      y:=y+printer.canvas.textheight(s);
      delete(s,1,i);
    end;
  end;

var px,py:array[1..4] of integer;
    p0:byte;
begin
  if MessageDlg('Karteikarte drucken?',mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;
  Printer.Orientation := poLandscape;
  Printer.Title:='Ausleihsystem - Karteikarte';
  Printer.BeginDoc;
  px[1]:=0;   py[1]:=0;
  px[2]:=printer.pagewidth div 2+50;   py[2]:=0;
  px[3]:=0; py[3]:=printer.pageheight div 2+50;
  px[4]:=printer.pagewidth div 2+50; py[4]:=printer.pageheight div 2+50;
  Printer.Canvas.PolyLine([Point(0, Printer.PageHeight div 2),
                           Point(Printer.PageWidth, Printer.PageHeight div 2)]);
  Printer.Canvas.PolyLine([Point(Printer.PageWidth div 2,0),
                           Point(Printer.PageWidth div 2, Printer.PageHeight)]);

  for p0:=1 to 4 do begin
    x:=px[p0]; y:=py[p0];
    printer.canvas.font.name:='Courier New';
    printer.canvas.font.size:=24;
    out(table2.fieldbyname('Datum').AsString+'     '+
        table2.fieldbyname('Inv').AsString,40);
    printer.canvas.font.size:=12;
    out(' ',1);
    out(table2.fieldbyname('Autor').AsString,50);
    out(' ',1);
    out(table2.fieldbyname('Titel').AsString,50);
    out(' ',1);
    printer.canvas.font.size:=8;
    out(table1.fieldbyname('Vorname').AsString+' '+
        table1.fieldbyname('Name').AsString,80);
    out(table1.fieldbyname('Adresse').AsString,80);
    out(table1.fieldbyname('Tel').AsString,80);
    out(table1.fieldbyname('E-mail').AsString,80);
    out(table1.fieldbyname('EID').AsString,80);
    printer.canvas.font.size:=12;
    out(' ',1);
    out('Unterschrift  _____________________________________',80);
    out(' ',1);
    printer.canvas.font.size:=6;
    out('Bibliothek der Mathematik, Uni Bonn, Wegelerstr. 10, 53117 Bonn',100);
    out('Tel: 0228/73-2209  Fax: -3333  E-Mail: bibliothek@math.uni-bonn.de',100);
    out('Im Internet:  http://bib.math.uni-bonn.de/',100);
  end;
  Printer.EndDoc;
end;


procedure TMainForm.Table2AfterInsert(DataSet: TDataset);
begin
  PrintButton.click;
end;

procedure TMainForm.Personen1Click(Sender: TObject);
  function cut(len:byte;s:string):string;
  begin
    while length(s)<len do s:=s+' ';
    cut:=copy(s,1,len);
  end;

var t:textfile;
begin
  if DruckForm.ShowModal<>mrOK then exit;
  printer.orientation:=poPortrait;
  assignprn(t); rewrite(t);
  printer.canvas.font.name:='Courier New';
  with table1 do begin
    first;
    while not EOF do begin
      if table2.recordcount >0 then begin
        printer.canvas.font.size:=12;
        writeln(t,FieldByName('Name').AsString,', ',FieldByName('Vorname').AsString);
        printer.canvas.font.size:=10;
        writeln(t,'     ',FieldByName('Adresse').AsString);
        writeln(t,'     ',FieldByName('Tel').AsString,
                  '     ',FieldByName('E-Mail').AsString,
                  '     ',FieldByName('EID').AsString);
        table2.first;
        while not table2.EOF do begin
          printer.canvas.font.size:=12;
          writeln(t,'   ',
                  cut(12,Table2.Fieldbyname('Datum').asstring),' ',
                  cut(12,Table2.Fieldbyname('Rueck').asstring),' ',
                  cut(12,Table2.Fieldbyname('inv').asstring));
          writeln(t,'      ',
                  cut(30,Table2.Fieldbyname('autor').asstring),' ',
                  cut(30,Table2.Fieldbyname('titel').asstring));
          Table2.next;
        end;
        writeln(t);
      end;
      next;
    end;
    first;
  end;
  closefile(t);
end;

end.
